/* xlglob.h -- external declarations for global variables */

/* symbols */
extern struct node isnil;

extern LVAL s_true,obarray;
extern LVAL s_features;
extern LVAL s_unbound,s_dot;
extern LVAL s_quote,s_identity,s_function;
extern LVAL s_bquote,s_comma,s_comat;
extern LVAL s_evalhook,s_applyhook,s_tracelist;
extern LVAL s_lambda,s_macro;
extern LVAL s_stdin,s_stdout,s_stderr,s_debugio,s_traceout;
extern LVAL s_rtable;
extern LVAL s_tracenable,s_tlimit,s_breakenable;
extern LVAL s_setf,s_setfl,s_car,s_cdr,s_apply,s_nth;
extern LVAL s_aref,s_get,s_getf;
extern LVAL s_svalue,s_sfunction,s_splist;
extern LVAL s_eql,s_gcflag,s_gchook;
extern LVAL s_ifmt,s_ffmt;
#ifdef RATIOS
extern LVAL s_rfmt;
#endif
extern LVAL s_1plus,s_2plus,s_3plus;
extern LVAL s_1star,s_2star,s_3star;
extern LVAL s_minus,s_printcase;
extern LVAL s_printlevel, s_printlength;
extern LVAL s_dispmacros;
extern LVAL s_strtypep, s_mkstruct, s_cpystruct;
extern LVAL s_prntfunc;
extern LVAL s_strref, s_strset;
extern LVAL s_x, s_s, s_sslots;
extern LVAL s_elt;
extern LVAL a_list, a_number, a_null, a_atom, a_anystream;
extern LVAL s_and, s_or, s_not, s_satisfies, s_member;
extern LVAL a_struct;
extern LVAL s_read_suppress;
#ifdef DOSINPUT
extern LVAL s_dosinput;
#endif
#ifdef HASHFCNS
extern LVAL s_gethash, a_hashtable;
#endif
extern LVAL a_complex;
#ifdef RANDOM
extern LVAL s_randomstate, a_randomstate;
#endif
#ifdef READTABLECASE
extern LVAL s_rtcase;
#endif
#ifdef PACKAGES
extern LVAL xlisppack, xlkeypack, xluserpack, s_package;
#endif /* PACKAGES */
extern LVAL s_load;

/* keywords */
extern LVAL k_and, k_or, k_not;
extern LVAL k_test,k_tnot;
extern LVAL k_wspace,k_const,k_nmacro,k_tmacro;
extern LVAL k_sescape,k_mescape;
extern LVAL k_direction,k_input,k_output;
extern LVAL k_start,k_end,k_1start,k_1end;
extern LVAL k_2start,k_2end,k_count;
extern LVAL k_verbose,k_print;
extern LVAL k_upcase,k_downcase,k_capitalize;
extern LVAL k_io, k_elementtype;
extern LVAL s_termio, k_exist, k_nexist, k_error;
extern LVAL k_rename, k_newversion, k_overwrite, k_append;
extern LVAL k_supersede, k_rendel, k_probe, k_create;
extern LVAL k_concname, k_include, k_prntfunc;
extern LVAL k_initelem, k_initcont;
extern LVAL k_allow_other_keys;	 /* TAA added 9/93 */
extern LVAL k_displacedto;
#ifdef REDUCE
extern LVAL k_ivalue;
#endif
#ifdef KEYARG
extern LVAL k_key;
#endif
#ifdef HASHFCNS
extern LVAL k_size;
#endif
#ifdef RANDOM
extern LVAL k_data;
#endif
#ifdef READTABLECASE
extern LVAL k_preserve,k_invert;
#endif
#ifdef PACKAGES
extern LVAL k_nicknames, k_use;
#ifdef MULVALS
extern LVAL k_internal, k_external, k_inherited;
#endif /* MULVALS */
#endif /* PACKAGES */
#ifdef CONDITIONS
extern LVAL s_condition_hook;
extern LVAL s_error, s_cerror, s_signal, s_warn, s_break, s_debug;
extern LVAL s_unboundvar, s_unboundfun;
extern LVAL k_name;
#endif /* CONDITIONS */
extern LVAL s_keepdocs, s_fundoc, s_aref,s_row_major_aref, s_otherwise;
extern LVAL s_intaction, s_baktraceprargs, s_strict_keywords;
extern LVAL s_destructbind;
extern LVAL s_typespec, s_batchmode, k_fromend;
extern LVAL s_eq,s_equal;
extern LVAL s_printgensym,s_printreadably,s_printescape;
extern LVAL k_construct, k_predicate;
extern LVAL s_strinclude, s_strconstruct;
extern LVAL a_integer;
#ifdef BYTECODE
extern LVAL a_bcclosure, a_cpsnode, a_bcode, s_stdrtable;
#endif /* BYTECODE */
#ifndef XLISP_ONLY
extern LVAL a_adata;
extern char *defaultpath;
#endif /* XLISP_ONLY */
#ifdef HASHFCNS
extern LVAL k_rhthresh, k_rhsize;
#endif
extern LVAL a_rndstate, s_rndstate;
extern LVAL a_array;        /* L. Tierney */
extern LVAL s_vardoc;
extern LVAL a_tvec;
extern LVAL s_c_char, s_c_short, s_c_int, s_c_long, s_c_float, s_c_double;
extern LVAL s_c_complex, s_c_dcomplex, s_make_array;
#ifdef IEEEFP
extern LVAL s_posinfinity, s_neginfinity, s_notanumber;
#endif
#ifdef PACKAGES
extern LVAL s_printsympack;
#endif /* PACKAGES */
#ifdef PRINTCIRCLE
extern LVAL s_printcircle, s_prcircdat, s_rdcircdat;
#endif /* PRINTCIRCLE */

/* lambda list keywords */
extern LVAL lk_optional,lk_rest,lk_key,lk_aux;
extern LVAL lk_allow_other_keys;
extern LVAL lk_whole,lk_body,lk_environment;

/* type names */
extern LVAL a_subr,a_fsubr;
extern LVAL a_cons,a_symbol,a_fixnum,a_flonum;
extern LVAL a_string,a_object,a_stream,a_vector;
extern LVAL a_closure,a_char,a_ustream;
#ifdef RATIOS
extern LVAL a_ratio;
extern LVAL a_rational;
#endif
#ifdef PACKAGES
extern LVAL a_package;
#endif /* PACKAGES */

/* Object system */
extern LVAL s_self,k_new,k_isnew;
extern LVAL k_prin1;
extern LVAL cls_class,cls_object;

#ifdef MSDOS
extern LVAL k_data, k_type, k_item, k_timeout, k_request;
#endif /* MSDOS */
#ifdef MACINTOSH
extern LVAL k_appllistlabel, k_canswitch, k_data, k_name, k_object, k_prompt;
extern LVAL k_signature, k_timeout, k_type, k_waitreply, k_zone;
#endif /* MACINTOSH */

/* evaluation variables */
extern LVAL **xlstktop;             /* top of the evaluation stack */
extern LVAL **xlstkbase;            /* base of the evaluation stack */
extern LVAL **xlstack;	            /* evaluation stack pointer */
extern LVAL xlenv,xlfenv,xldenv;    /* environment pointers */

/* argument stack */
extern LVAL *xlargstkbase;      /* base of the argument stack */
extern LVAL *xlargstktop;       /* top of the argument stack */
extern LVAL *xlfp;		/* argument frame pointer */
extern LVAL *xlsp;		/* argument stack pointer */
extern LVAL *xlargv;		/* current argument vector */
extern int xlargc;		/* current argument count */

/* continuation stack */
#ifdef BYTECODE
extern CONTINUATIONP xlcontinuation_stack, xlcstop, xlcsend;
extern LVAL *vsbase;
#define vstop xlsp
#endif /* BYTECODE */

/* exception handling variables */
extern CONTEXT *xlcontext;	/* current exception handler */
extern CONTEXT *xltarget;	/* target context (for xljump) */
extern LVAL xlvalue;		/* exception value (for xljump) */
extern int xlmask;		/* exception type (for xljump) */
#ifdef MULVALS
extern int xlnumresults;	/* number of values */
extern LVAL *xlresults;         /* multiple values array */
#endif /* MULVALS */

/* Garbage collection reporting variables */
extern long gccalls, nfree, total;

/* debugging variables */
extern int xldebug;	   /* debug level */
extern int xlsample;	   /* control character sample rate */
extern int xltrcindent;	   /* trace indent level */

/* gensym variables */
extern char gsprefix[];	    /* gensym prefix string */
extern FIXTYPE gsnumber;    /* gensym number */

/* i/o variables */
extern int xlfsize;	    /* flat size of current print call */
extern FILEP tfp;	    /* transcript file pointer */
extern int redirectout;	    /* output is redirected */
extern int redirectin;	    /* input is redirected */
extern int batchmode;	    /* running a batch process */
extern int lposition;	    /* postition in screen */

/* From Luke Tierney, 9/93 */
/* startup functions and command line symbols */
extern LVAL s_startup_functions, s_command_line;
extern LVAL s_loadfileargs, s_toplevelloop;

/* general purpose string buffer */
extern char buf[];

/* remaining nodes */
extern long nnodes;

/* printing level and length */
extern int plevel, plength;

#ifdef STSZ
/* For stack checking */
extern int stackwarn;	    /* is TRUE when warning given */
extern int marghi;	    /* stackleft for warning */
#endif

#ifdef FILETABLE
extern FILETABLETYPE filetab[FTABSIZE];
#endif

#ifdef ASCII8
/* conversion tables for 8 bit ASCII */
extern char ascii8tbl[];
extern unsigned char ascii8cnv[];
#endif

/* defined in xlisp.c */
#ifdef SAVERESTORE
extern jmp_buf top_level;
#endif

/* defined in xlftab.c */
/* external variable from xlftab.c */
#ifdef _Windows   /* L. Tierney */
    extern FUNDEF far funtab[];
#else
    extern FUNDEF funtab[];
#endif
extern int ftabsize;	/* TAA MOD -- added validity check */

/* $putpatch.c$: "MODULE_XLGLOB_H_GLOBALS" */
